
#if !defined(AFX_ZOR_H__DEE8D4E5_3AB8_45F8_8C03_B4A169FF7D3D__INCLUDED_)
#define AFX_ZOR_H__DEE8D4E5_3AB8_45F8_8C03_B4A169FF7D3D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#if(_WIN32_WINNT >= 0x0501)
#define CB_GETCOMBOBOXINFO 0x0164
#endif /* _WIN32_WINNT >= 0x0501 */


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@  INCLUDES
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#include "resource.h"
#include "../lib/general.hpp"
#include "../lib/file_mapper.hpp"
#include "../lib/rc4.hpp"
#include <cstdio>
#include <windows.h>
#include <string>
#include <errno.h>
#include <vector>
#include <algorithm>



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@  NAMESPACES
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
using namespace std;



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@  CONSTANTS
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#define MAX_KEY_SIZE		128
#define MAX_BUF				30000
#define FOLDER_NAME_SIZE	1024
#define TMP_BUFSIZE			256

#define UI08	unsigned char
#define SI08 	signed char
#define UI16	unsigned short
#define SI16	signed short
#define UI32	unsigned int
#define SI32	signed int
#define UI64	unsigned long
#define SI64	signed long

const UI32 MAX_LOADSTRING		= 100;


#ifndef BIF_NEWDIALOGSTYLE
	#define BIF_NEWDIALOGSTYLE 0x0040
#endif // !BIF_NEWDIALOGSTYLE


//===============================================================
class Cfolder_unit
{
public:
	string m_name;

	bool operator < (const Cfolder_unit& _s) {
		return (m_name.size() > _s.m_name.size());
	}
};


class Cglobal
{
public:
	HWND					saved_hWnd;
	HDC						glob_hdc;
	bool					recursive;
	UI32					nb_erase_pass;
	bool					folder_scan_cancelled;
	bool					running_flag;
	vector<string>			v_file;	
	vector<Cfolder_unit>	v_folder;	
	Crc4					rc4_gen;
	UI32					current_pass;

	HINSTANCE		hInst;								
	TCHAR			szTitle[MAX_LOADSTRING];		
	TCHAR			szWindowClass[MAX_LOADSTRING];

	Cglobal  ();
};



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@  GENERAL FUNCTIONS
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
bool				erase_content_fopen (CCPTR, UI32, Cbar&);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void				center_window (HWND);
bool				extract_directory_list (string& dirname, vector<string>&);
bool				explore_one_directory (string dirname, string);
void				explore_all_from_local_root (string);
void				gather_files_and_folders_recursive (CCPTR);
bool				gather_files_and_folders_not_recursive (CCPTR);
DWORD WINAPI		doit_process_folder (LPVOID);
bool				doit_encode_folder ();
void				reset_view ();
void				enable_controls (bool, bool);
void				disable_controls (bool, bool);



#endif // !defined(AFX_ZOR_H__DEE8D4E5_3AB8_45F8_8C03_B4A169FF7D3D__INCLUDED_)
