#ifndef __STEG_MD5_FLAG__
#define __STEG_MD5_FLAG__

#include "../lib/general.hpp"
#include "../lib/file_mapper.hpp"


using namespace std;

#ifdef __alpha
typedef unsigned int uint32;
#else
typedef unsigned long uint32;
#endif

#define SI32			signed int
#define GENERAL_ERROR	-1
#define CRC_SIZE	32

const SI32	MAXBUF_MD5		= 256;


struct MD5Context {
	uint32 buf[4];
	uint32 bits[2];
	unsigned char in[64];
};

void MD5Init(struct MD5Context *context);
void MD5Update(struct MD5Context *context, unsigned char const *buf,
	       unsigned len);
void MD5Final(unsigned char digest[16], struct MD5Context *context);
void MD5Transform(uint32 buf[4], uint32 const in[16]);

/*
 * This is needed to make RSAREF happy on some MS-DOS compilers.
 */
typedef struct MD5Context MD5_CTX;



string compute_md5_hash (CCPTR);
string compute_md5_hash_using_mmap (CCPTR, bool&);
string compute_md5_hash (UI08 * _buf, UI32);
void compute_md5_hash (UI08 * _buf, UI32 _file_size, UI08 *);

#endif // __STEG_MD5_FLAG__
