// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ INCLUDES
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#include "rc4.hpp"


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ EXTERNAL VARIABLES
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#if defined (__GUI_RC4__)
	extern HWND				remote_hwnd;
	extern unsigned long	idc_status;
	extern unsigned long	idc_progress1;
	extern unsigned long	idc_progress2;
	extern void disable_controls (bool, bool);
	extern void enable_controls (bool, bool); 
#endif // __GUI_RC4__


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ GLOBAL VARIABLES
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Cglobal_rc4 glob_rc4;


void Cglobal_rc4::evaluate_randomness () {
	FILE * fp_dest = fopen ("C:\\bootleg.bin", "wb");
	if (fp_dest) {
		fwrite (glob_rc4.rc4_tab, RC4_THREAD_BUFSIZE, 1, fp_dest);
		fclose (fp_dest);
	}
}
//-------------------------------------------

Crc4::Crc4 () {
	preparation_flag = false;
}

void Crc4::prepare_internal_key (vector<UI08>& _v_key) {
	for (UI32 i=0 ; i<RANDOM_KEY_SIZE_IN_BYTE ; i++) {
		m_key[i] = _v_key[i]; // modulo is automatic (stored into a byte)			
	}
}

void Crc4::erase_key (vector<UI08>& _v_key) {
	SYSTEMTIME tim;
	GetLocalTime (&tim);
	srand (tim.wMilliseconds);

	UI32 size = _v_key.size ();
	// overwrite
	for (UI32 i=0 ; i<size ; i++) {
		_v_key[i] = rand();	
	}
	//... and erase
	_v_key.clear ();

	for (i=0 ; i<RANDOM_KEY_SIZE_IN_BYTE ; i++) {
		m_key[i] = rand();	
	}
}

void Crc4::key_schedule (vector<UI08>& _v_key) {
	UI32 i;
	for (i=0 ; i<S_ARRAY_SIZE ; i++) {
		m_s_array[i] = i;
	}
	
	prepare_internal_key (_v_key);

	UI08 j = 0; // automatic modulo
	UI08 tmp;
	UI32 key_index;
	for (i=0 ; i<S_ARRAY_SIZE ; i++) {
		key_index = i % RANDOM_KEY_SIZE_IN_BYTE;
		j = j + m_s_array[i] + m_key[key_index];
		// swap S[i],S[j]
		tmp				= m_s_array[i];
		m_s_array[i]	= m_s_array[j];
		m_s_array[j]	= tmp;
	}
	erase_key (_v_key);
}

bool Crc4::prepare (vector<UI08>& _v_key) {
	bool bret = true;
	if (_v_key.size() != RANDOM_KEY_SIZE_IN_BYTE) {
		bret = false;
	}
	else {	
		key_schedule (_v_key);

		m_iterator_i		= 0;
		m_iterator_j		= 0;
		preparation_flag	= true;	
	}
	return (bret);
}

void Crc4::prepare (Crc4& _rc4) {
	UI32 i=0;
	vector<UI08> v_key;
	for (i=0 ; i<RANDOM_KEY_SIZE_IN_BYTE ; i++) {
		v_key.push_back (_rc4.get_next_byte ());
	}
	prepare (v_key);
}

bool Crc4::is_prepared () {
	return (preparation_flag);
}

//--------------------------------
DWORD WINAPI doit_rc4 (LPVOID lParam) {
	UI32 current_thread = (UI32) GetCurrentThread ();
	CDuration bench;
	SYSTEMTIME tim;
	GetLocalTime (&tim);
	srand (current_thread + tim.wMilliseconds);
	// add some randomness to the result buffer
	for (UI32 i=0 ; i<RC4_THREAD_BUFSIZE ; i++) {
		glob_rc4.rc4_tab[i] += rand ();
	}
	GetLocalTime (&tim);
	srand (tim.wMilliseconds);
#if defined (__RC4_USE_DES__)
	Cdes des;
	UI32 nb_block = MD5_RAND_BUF_SIZE / DES_BLOCK_SIZE_IN_BYTE;
	UI32 nb_block_chosen = rand() % nb_block;
	UI32 index_key, index_src, index_dest;
	for (i=0 ; i<nb_block_chosen ; i++) {
		index_key	= (rand() % nb_block) * DES_BLOCK_SIZE_IN_BYTE;
		index_src	= (rand() % nb_block) * DES_BLOCK_SIZE_IN_BYTE;
		index_dest	= (rand() % nb_block) * DES_BLOCK_SIZE_IN_BYTE;
		des.decrypt (&glob_rc4.rc4_tab[index_key], &glob_rc4.rc4_tab[index_src], &glob_rc4.rc4_tab[index_dest]);
	}
#endif // __RC4_USE_DES__

	// wait for the start signal
	while (glob_rc4.start_thread == false) {
		Sleep (0);
	}

	UI32 index;
	UI32 srand_seed;
	UI08 val;
	for (UI32 k=0 ; k<RC4_THREAD_NB_LAP ; k++) {
		for (i=0 ; i<RC4_THREAD_BUFSIZE ; i++) {
			bench.start ();
			Sleep (0);
			bench.stop ();
			srand_seed = (UI32) bench.get_duration ();
			index = (srand_seed * glob_rc4.rc4_tab[index] * rand()) % RC4_THREAD_BUFSIZE;

			if ((index %2) == 0) {
				glob_rc4.rc4_tab[index] += rand ();
			}
			else {
				val = rand ();
				glob_rc4.rc4_tab[index] = glob_rc4.rc4_tab[index] ^ val;
			}
		}
	}
	return (0);
}

bool create_rc4_thread () {
	bool bret = true;
	DWORD dwThreadId;
	HANDLE hThread; 
	hThread = CreateThread (NULL,0, doit_rc4, NULL, 0, &dwThreadId);
	if (hThread == NULL)   {
		MessageBox (NULL, "Thread creation failed", "Error", MB_OK | MB_ICONERROR);			
		bret = false;
	}
	else {
		glob_rc4.v_thread_handle.push_back (hThread);
	}
	return (bret);
}

// the bootleg is a pseudo-randomly generated buffer that is generated
// using the fact that the thread scheduling and the system reaction time
// is unpredictable (depends on the system, the running processes, the CPU power,...)
void prepare_bootleg () {
	// create all threads
	glob_rc4.start_thread = false;
	for (UI32 i=0 ; i<RC4_NB_THREAD ; i++) {
		create_rc4_thread ();
	}
	Sleep (0); // let all the thread create themselves
	glob_rc4.start_thread = true; // let threads start

	// wait for all threads to finish their job
	for (i=0 ; i<RC4_NB_THREAD ; i++) {
		WaitForSingleObject (glob_rc4.v_thread_handle[i], INFINITE);
	}
	glob_rc4.v_thread_handle.clear ();
#if defined (__EVALUATE_RANDOMNESS_FLAG__)
	glob_rc4.evaluate_randomness ();
#endif // __EVALUATE_RANDOMNESS_FLAG__
}

void Crc4::generate_random_bootleg (Crc4& _result_gen) {
	Crc4 bootleg_gen;
	Crc4 gen_tab[NB_RAND_GEN];
	UI08 rand_buf[MD5_RAND_BUF_SIZE];
	UI32 nb_done = 0;
	UI32 i=0;
	UI08 val;
	UI08 md5_hash[MD5_HASH_SIZE_IN_BYTE];
	vector<UI08> v_key;
	UI32 nb_bytes_to_avoid; // first bytes generated by the RC4 is unsafe 
	SYSTEMTIME tim;

	// generate a random buffer (not using a fixed seed)
	prepare_bootleg ();
	// compute the MD5 hash of the random buffer 
	compute_md5_hash (glob_rc4.rc4_tab, RC4_THREAD_BUFSIZE, md5_hash);
	// prepare the main bootleg generator using the MD5 hash previously computed
	for (i=0 ; i<RANDOM_KEY_SIZE_IN_BYTE ; i++) {
		v_key.push_back (md5_hash[i % MD5_RAND_BUF_SIZE]);
	}
	bootleg_gen.prepare (v_key);

	GetLocalTime (&tim);
	srand (tim.wMilliseconds);
	nb_bytes_to_avoid = NB_RC4_BYTES_2_AVOID + (rand() % NB_RC4_BYTES_2_AVOID);
	// avoid to use the first 256 bytes generated by the RC4
	for (i=0 ; i<nb_bytes_to_avoid ; i++) {
		bootleg_gen.get_next_byte ();	
	}

	// prepare the bootleg generator set using the data generated by the
	// generator initialized using the MD5 hash previously computed
	for (i=0 ; i<NB_RAND_GEN ; i++) {
		gen_tab[i].prepare (bootleg_gen);	
		// avoid to use the first 256 bytes generated by the RC4
		GetLocalTime (&tim);
		srand (tim.wMilliseconds);
		nb_bytes_to_avoid = NB_RC4_BYTES_2_AVOID + (rand() % NB_RC4_BYTES_2_AVOID);
		for (UI32 k=0 ; k<nb_bytes_to_avoid ; k++) {
			gen_tab[i].get_next_byte ();	
		}
	}

	// generate a random buffer using the available set of bootleg generators
	for (i=0 ; i<MD5_RAND_BUF_SIZE ; i++) {
		val = gen_tab[i % NB_RAND_GEN].get_next_byte (); 
		rand_buf[i] = val;
	}

	// compute the MD5 hash of the random buffer
	compute_md5_hash (rand_buf, MD5_RAND_BUF_SIZE, md5_hash);

	// init the true random generator with the bootleg MD5
	for (i=0 ; i<RANDOM_KEY_SIZE_IN_BYTE ; i++) {
		v_key.push_back (md5_hash[i % MD5_RAND_BUF_SIZE]);
	}
	_result_gen.prepare (v_key);

	// avoid to use the first 256 bytes generated by the RC4
	GetLocalTime (&tim);
	srand (tim.wMilliseconds);
	nb_bytes_to_avoid = NB_RC4_BYTES_2_AVOID + (rand() % NB_RC4_BYTES_2_AVOID);
	for (i=0 ; i<nb_bytes_to_avoid ; i++) {
		_result_gen.get_next_byte ();	
	}
}


void Crc4::prepare_using_random_key () {
	preparation_flag = false;
	Crc4 bootleg[NB_BOOTLEG];
	// generate the random bootlegs
	UI32 i;
#if defined (__GUI_RC4__)
	disable_controls (true, true);
	Cbar file_bar, thread_bar;
	file_bar.init (remote_hwnd, idc_progress1, NB_BOOTLEG);
	thread_bar.init (remote_hwnd, idc_progress2, NB_BOOTLEG);
#endif // __GUI_RC4__
	char disp_buf[256];
	for (i=0 ; i<NB_BOOTLEG ; i++) {
#if defined (__GUI_RC4__)
		snprintf (disp_buf, DISP_BUFSIZE, "Random generator initialization (%u / %u)", i, NB_BOOTLEG);
		disp_buf[DISP_BUFSIZE - 1] = '\0';
		SendDlgItemMessage (remote_hwnd, idc_status, WM_SETTEXT, 0, (LPARAM) disp_buf);
#endif // __GUI_RC4__
		generate_random_bootleg (bootleg[i]);
#if defined (__GUI_RC4__)
		file_bar.incr (1);
		thread_bar.incr (1);
#endif // __GUI_RC4__ 
	}

	vector<UI08> v_key;
	UI08 val;
	for (i=0 ; i<RANDOM_KEY_SIZE_IN_BYTE ; i++) {
		// combine the results provided by all bootlegs to generate the key
		for (UI32 k=0 ; k<NB_BOOTLEG ; k++) {
			if (k==0) {
				val = bootleg[i%NB_BOOTLEG].get_next_byte ();
			}
			else {
				val = val ^ bootleg[i%NB_BOOTLEG].get_next_byte ();
			}
		}
		v_key.push_back (val);
	}
	prepare (v_key);
	preparation_flag = true;
#if defined (__GUI_RC4__)
	// clear the bars
	file_bar.init	(remote_hwnd, idc_progress1, NB_BOOTLEG);
	thread_bar.init (remote_hwnd, idc_progress2, NB_BOOTLEG);
	enable_controls (true, true);
#endif // __GUI_RC4__
}

/*
i := 0
j := 0
while GeneratingOutput:
    i := (i + 1) mod 256
    j := (j + S[i]) mod 256
    swap(S[i],S[j])
    output S[(S[i] + S[j]) mod 256]
endwhile
*/
UI08 Crc4::get_next_byte () {
	UI08 result = 0;
	UI08 tmp;

	m_iterator_i++;
	m_iterator_j = m_iterator_j + m_s_array[m_iterator_i];
	//swap(S[i],S[j])
	tmp = m_s_array[m_iterator_i];
	m_s_array[m_iterator_i] = m_s_array[m_iterator_j];
	m_s_array[m_iterator_j] = tmp;	
	
	UI08 final_index = m_s_array[m_iterator_i] + m_s_array[m_iterator_j];
	result = m_s_array[final_index];
	return (result);
}

UI32 Crc4::get_next () {
	UI32 result = 0;
	for (UI32 i=0 ; i<4 ; i++) {
		atyp.a_UI08[i] = get_next_byte ();	
	}
	result = atyp.a_UI32;
	return (result);
}

