// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ multiple inclusion problem avoidance
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#ifndef __RC4_ALGO_FLAG__
#define __RC4_ALGO_FLAG__



// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ includes
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <windows.h>
#include "../lib/md5.hpp"
#if defined (__RC4_USE_DES__)
	#include "../lib/des_tool.hpp"
#endif // __RC4_USE_DES__

#define UI32					unsigned int
#define SI32					signed int
#define UI08					unsigned char
#define RAND_EVAL_NB_LAP		10000000
#define NB_RAND_GEN				10
#define	MD5_RAND_BUF_SIZE		64 * 8 
#if defined (__RC4_USE_DES__)
	#define DES_BLOCK_SIZE_IN_BYTE 8
#endif // __RC4_USE_DES__
#define MD5_HASH_SIZE_IN_BYTE	16
#define RANDOM_KEY_SIZE_IN_BYTE 16
#define S_ARRAY_SIZE			256
#define NB_RC4_BYTES_2_AVOID	256
#define NB_BOOTLEG				16

#define RC4_THREAD_NB_LAP		10
#define RC4_THREAD_BUFSIZE		2048
#define RC4_NB_THREAD			25
#define DISP_BUFSIZE			256


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ namespace usage declaration
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
using namespace std;

union Atyp_rc42 {
	UI08 a_UI08[4];
	UI32 a_UI32;
};


class Cglobal_rc4
{
public:
	UI08				rc4_tab[RC4_THREAD_BUFSIZE];
	bool				start_thread;
	vector<HANDLE>		v_thread_handle;
#if defined (__GUI_RC4__)
	Cbar				thread_bar;
#endif // __GUI_RC4__

	Cglobal_rc4 () {
		start_thread = false;
	}

	void evaluate_randomness ();
};


class Crc4
{
private:
	Atyp_rc42	atyp;
	UI08		m_iterator_i;
	UI08		m_iterator_j;
	UI08		m_s_array[S_ARRAY_SIZE];
	UI08		m_key[RANDOM_KEY_SIZE_IN_BYTE];
	bool		preparation_flag;
	void		key_schedule (vector<UI08>&);

	void		prepare_internal_key (vector<UI08>&);
	void		generate_random_bootleg (Crc4&);
	void		erase_key (vector<UI08>&);

public:
	Crc4 ();
	void		evaluate_randomness ();
	void		prepare_using_random_key ();
	bool		prepare (vector<UI08>&);
	void		prepare (Crc4&);

	UI08		get_next_byte ();
	UI32		get_next ();
	bool		is_prepared ();
};


#endif // #define __RC4_ALGO_FLAG__



// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@  end of file
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

