// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ FILE: data_types.hpp
// @@ 
// @@ DESCRIPTION:
// @@ This file contains all the platform 
// @@ independant data types that are to be used 
// @@ instead of the system dependant types.
// @@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ multiple inclusion problem avoidance
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#ifndef __DATA_TYPES_FLAG__
#define __DATA_TYPES_FLAG__



// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ includes
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@ data types
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#if ! defined (UI08)
	#define UI08	unsigned	char
#endif // UI08

#if ! defined (CPTR)
	#define CPTR				char *
#endif // #if ! defined (CPTR)

#if ! defined (SPTR)
	#define SPTR				signed char *
#endif // #if ! defined (SPTR)

#if ! defined (CCPTR)
	#define CCPTR	const		char *
#endif // #if ! defined (CCPTR)

#if ! defined (CPUI08)
	#define CPUI08	const		UI08 *
#endif // #if ! defined (CPUI08) 

#if ! defined (SI08)
	#define SI08	signed		char
#endif // #if ! defined (SI08)

#if ! defined (UI16)
	#define UI16	unsigned	short
#endif // #if ! defined (UI16)

#if ! defined (SI16)
	#define SI16	signed		short
#endif // #if ! defined (SI16)

#if ! defined (SI32)
	#define SI32	signed		int
#endif // #if ! defined (SI32)

#if ! defined (UI32)
	#define UI32	unsigned	int
#endif // #if ! defined (UI32)

#if ! defined (UI64)
	#define UI64	unsigned	long
#endif // #if ! defined (UI64)

#if ! defined (RI32)
	#define RI32	float
#endif // #if ! defined (RI32)

#if ! defined (RI64)
	#define RI64	double
#endif // #if ! defined (RI64)

#if defined (__WIN32_OS__) 
	#define snprintf _snprintf
#endif // #if defined (__WIN32_OS__) 

#if defined (__LINUX_OS__)
	#define	SOCKET int
#endif // #if defined (__LINUX_OS__)

#endif // __DATA_TYPES_FLAG__



// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@  end of file
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
